local cars = {
    -- name -  
    -- id -   (   /dl )
    -- weight - 

    { name = "Volkswagen Constellation", id = 15328, weight = 20000 },
    { name = "Mercedes-Benz 1620",       id = 15326, weight = 15000 },
    { name = "Mercedes-Benz 1113",       id = 15327, weight = 10000 },
    { name = "Opel Vivaro Courier",      id = 15564, weight = 5000 },
}

local orders = {}


function onReceivePacket(id, bs)
    if id == 220 then
        id = raknetBitStreamReadInt8(bs)
        local action_id = raknetBitStreamReadInt8(bs)

        if action_id == 17 then
            local string = read_packet(bs)

            if string:find("window.executeEvent%('event.setActiveView', `%[\"Truckers\"%]`%)") then
                orders = {}
            elseif string:find("event.truckers.initializeTruckersData") then
                local data = decodeJson(string:match("`(.-)`"))[1][1]
                local car_info = get_current_car()

                local weight = tonumber(data.product:match("%((%d+).+%)"))
                local priority = weight / data.distance

                if
                    car_info and
                    weight <= car_info.weight
                then
                    data.priority = priority
                    table.insert(orders, data)
                end

                lua_thread.create(function()
                    local orders_count = #orders
                    wait(100)

                    if orders_count == #orders then
                        local max_priority = 0

                        for k, v in pairs(orders) do
                            if v.priority > max_priority then
                                max_priority = v.priority
                            end
                        end

                        for k, v in pairs(orders) do
                            if not v.sended then
                                v.sended = true
                                if v.priority == max_priority then
                                    v.priority_max = true
                                end
                                v.priority = tonumber(("%.3f"):format(v.priority))

                                local str = string.format("window.executeEvent('event.truckers.initializeTruckersData', `[[%s]]`);", encodeJson(v))
                                local new_bs = raknetNewBitStream()

                                raknetBitStreamWriteInt8(new_bs, 17)
                                raknetBitStreamWriteInt32(new_bs, 0)
                                raknetBitStreamWriteInt32(new_bs, #str)
                                raknetBitStreamWriteString(new_bs, str)
                                raknetBitStreamWriteInt32(new_bs, 255)
                                raknetEmulPacketReceiveBitStream(220, new_bs)
                                raknetDeleteBitStream(new_bs)
                            end
                        end
                    end
                end)

                return false
            end
        end
    end
end










function table.filter(tbl, condition)
    local result = {}
    for i, v in ipairs(tbl) do
        if condition(v) then
            table.insert(result, v)
        end
    end
    return result
end

function get_current_car()
    local res = nil

    if isCharInAnyCar(PLAYER_PED) then
        res = table.filter(cars, function(car) return car.id == getCarModel(storeCarCharIsInNoSave(PLAYER_PED)) end)[1]
    end

    return res
end

function read_packet(bs)
    local res = ""

	for i = 1, raknetBitStreamGetNumberOfBytesUsed(bs) do
		local int = raknetBitStreamReadInt8(bs)

		if int >= 32 and int <= 255 then
			res = res .. string.char(int)
		end
	end

	raknetBitStreamResetReadPointer(bs)

	return res
end